(in-package :om)

(defun cadena (pcs cant) 
  (let ((temp nil) (result nil) (ind 0))
     (loop for x from 1 to cant do
           (setf temp (permut-random (pc-set :integer pcs)))
           (if (nth-random '(t nil)) (setf temp (inv-12 temp)))
           (push (setf temp ( cdr (transp-pc temp ind))) result)
           (setf ind (last-elem temp)))
    (flat (list 0 (reverse result)))))

(defun inv-12 (pc-list)
  (mapcar #' (lambda (i)(mod (- 12 i) 12)) pc-list))

(defun transp-pc (pc-list ind)
  (mapcar #' (lambda (i)(mod (+ (- ind (first pc-list)) i) 12)) pc-list))

(defun transposicion (pc-list ind)
  (mapcar #' (lambda (i)(mod (+ ind  i) 12)) pc-list))

(defun inversion (pc-list)
  (transp-pc (mapcar #' (lambda (i)(- 12 i)) pc-list) (first pc-list)))

(defvar *puntero-notas* -1)

(defun obtener-notas (notas cantidad)  
  (let ((len (1- (length notas)))(res))
    (loop for i from 1 to cantidad do 
          (if(>= *puntero-notas* len) (setf *puntero-notas* -1))
          (push (nth (setf *puntero-notas* (1+ *puntero-notas*)) notas) res))
    (reverse res)))
        
(defun inicializar-puntero-notas ()    
  (setf *puntero-notas* -1))
